function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { PrimaryColumn, Entity, Index, JoinColumn, Column, ManyToOne } from "typeorm";
import { User } from "./user.js";
import { id } from "../id.js";
export let Following = class Following {
    id;
    createdAt;
    followeeId;
    followee;
    followerId;
    follower;
    //#region Denormalized fields
    followerHost;
    followerInbox;
    followerSharedInbox;
    followeeHost;
    followeeInbox;
    followeeSharedInbox;
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], Following.prototype, "id", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        comment: "The created date of the Following."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], Following.prototype, "createdAt", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        comment: "The followee user ID."
    }),
    _ts_metadata("design:type", Object)
], Following.prototype, "followeeId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], Following.prototype, "followee", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        comment: "The follower user ID."
    }),
    _ts_metadata("design:type", Object)
], Following.prototype, "followerId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], Following.prototype, "follower", void 0);
_ts_decorate([
    Index(),
    Column("varchar", {
        length: 512,
        nullable: true,
        comment: "[Denormalized]"
    }),
    _ts_metadata("design:type", Object)
], Following.prototype, "followerHost", void 0);
_ts_decorate([
    Column("varchar", {
        length: 512,
        nullable: true,
        comment: "[Denormalized]"
    }),
    _ts_metadata("design:type", Object)
], Following.prototype, "followerInbox", void 0);
_ts_decorate([
    Column("varchar", {
        length: 512,
        nullable: true,
        comment: "[Denormalized]"
    }),
    _ts_metadata("design:type", Object)
], Following.prototype, "followerSharedInbox", void 0);
_ts_decorate([
    Index(),
    Column("varchar", {
        length: 512,
        nullable: true,
        comment: "[Denormalized]"
    }),
    _ts_metadata("design:type", Object)
], Following.prototype, "followeeHost", void 0);
_ts_decorate([
    Column("varchar", {
        length: 512,
        nullable: true,
        comment: "[Denormalized]"
    }),
    _ts_metadata("design:type", Object)
], Following.prototype, "followeeInbox", void 0);
_ts_decorate([
    Column("varchar", {
        length: 512,
        nullable: true,
        comment: "[Denormalized]"
    }),
    _ts_metadata("design:type", Object)
], Following.prototype, "followeeSharedInbox", void 0);
Following = _ts_decorate([
    Entity(),
    Index([
        "followerId",
        "followeeId"
    ], {
        unique: true
    })
], Following);
